import math
import os
import sys

def hamilton(a,b,c):                                                    # Energy of the hydrogen bond
        d=1
        r=2.75
        energy=((3741298.17*(pow((1/a),12)))-(593660.53*(pow((1/a),10))))*pow(math.cos(3.14*b/180),2)*pow(math.cos(3.14*c/180),2)
        return energy
        

def norm(arr1,arr2):                                                    #  Calculating distance between two atoms
        x1=float(arr1[2])
        y1=float(arr1[3])
        z1=float(arr1[4])
        x2=float(arr2[2])
        y2=float(arr2[3])
        z2=float(arr2[4])
        dist=(x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(z1-z2)*(z1-z2)
        dist=pow(dist,0.5)
        return dist
        
def angle(a,b,c):                                                       # Calculating angle between 3 atoms
        ratio=0.0
        ratio=(a*a+b*b-c*c)/(2*b*a)
        theta=math.acos(ratio)
        return 180.0*theta/3.14
        

class distance:
        fin=open(sys.argv[1],"r")                                       # Taking the input file from the user
        linlist=fin.readline()
        while (linlist.split()[0]!='ATOM'):
                linlist=fin.readline()
        nitrogen=[]     
        oxygen=[]
        hydrogen=[]
        carbon=[]
        lst=linlist.split()
        residnum=1
        residnumh=1
        tempo=[]
        while (lst[0]=="ATOM"):         
                newlst=[]               
                newlst.append(lst[3])                                   # Residue type
                newlst.append(lst[2])                                   # ATOM type
                newlst.append(lst[5])                                   # X coordinate
                newlst.append(lst[6])                                   # Y coordinate
                newlst.append(lst[7])                                   # Z coordinate
                newlst.append(lst[4])                                   # Residue number
                if (newlst[1]=='N'):                                    #Adding the 'N'coordinates of the residue
                        nitrogen.append(newlst)
                        residnum+=1
                if (newlst[1]=='O'):                                    #Adding the 'O' coordinates of the residue              
                        oxygen.append(newlst)
                if (newlst[1]=='C'):                                            
                        carbon.append(newlst)                           # Adding the 'C' coordinates of the residue
                if (newlst[1]=='H'):
                        residnumh+=1                                    # Adding the 'H' coordinates of the residue
                        hydrogen.append(newlst) 
                        while (residnumh<residnum):                     # Adding only those 'N' coordinates for which a 'H' is present 
                                nitrogen[residnum-3]=[]
                                tempo=nitrogen[residnum-2]
                                nitrogen[residnum-3]=tempo
                                nitrogen.pop(residnum-2)
                                residnum-=1                                             
                linlist=fin.readline()          
                lst=linlist.split()             
        lennitro=len(nitrogen)
        lenoxy=len(oxygen)
        lenh=len(hydrogen)
        lenc=len(carbon)
        #print lennitro,lenh, lenoxy, lenc
        distNH=0
        distHO=0
        distNO=0
        distCO=0
        distCH=0
        oxynitro=0
        energy=0
        fin.close()
        fin=open("Hydrogen_Bond.txt","w")
        for kk in range(0,lennitro):
                for ll in range(0,lenoxy):                                                    #Calculation the distance between every nitrogen and oxygen atom
                        if((float(nitrogen[kk][4])-float(oxygen[ll][4])>4)):
                                continue                        
                        oxynitro=norm(nitrogen[kk],oxygen[ll])
			distNH=norm(nitrogen[kk],hydrogen[kk])
                        distNO=norm(nitrogen[kk],oxygen[ll])
                        distHO=norm(hydrogen[kk],oxygen[ll])
			oxnitang=angle(distNH,distNO,distHO)
			if((oxynitro<=3.5) & (oxnitang<=30) ):
                                fin.write(str("Length between nitrogen of residue "))
                                fin.write(str(nitrogen[kk][5]))
                                fin.write(str(" and oxygen of residue no "))
                                fin.write(str(oxygen[ll][5]))
                                fin.write(str(" is "))
                                fin.write(str(norm(nitrogen[kk],oxygen[ll])))
                                fin.write(str('\n'))    
                                distNH=norm(nitrogen[kk],hydrogen[kk])
                                distNO=norm(nitrogen[kk],oxygen[ll])
                                distHO=norm(hydrogen[kk],oxygen[ll])
                                fin.write(str("Angle between N,H,O is "))
                                fin.write(str(angle(distNH,distNO,distHO)))
                                fin.write(str('\n'))
                                distCO=norm(carbon[ll],oxygen[ll])
                                distCH=norm(hydrogen[kk],carbon[ll])
                                s=hamilton(distNO,angle(distCO,distHO,distCH),angle(distNH,distHO,distNO))
                                fin.write(str("Hydrogen bond energy is:"))                              
                                fin.write(str(s))
                                fin.write('\n')
                                energy+=hamilton(distNO,angle(distCO,distHO,distCH),angle(distNH,distHO,distNO))
        fin.write(str("Total hydrogen bond energy is "))
        fin.write(str(energy))
        fin.write(str(" Kcal/mol "))
        fin.close()
                        

                
